###########################################################################
# Powered by www.3ds.ir
###########################################################################

"Curve Refinement XML derived class"

from abaqus import *
from abaqusConstants import *

import os.path

execfile(os.path.join(os.path.dirname(os.path.dirname(__file__)), "commonExec.py")) # Initializes the importFile function
(abqXML, xmlUtils) = importFile(__file__, ("caeXML_3DS_IR.kernel.abqXML", "caeXML_3DS_IR.kernel.xmlUtils")) # Allows base-package directory to be changed
(settingsModule, ) = importFile(__file__, ("caeXML_3DS_IR.curveRefinement.curveSettings", )) # Settings Module

################################################################################

class CurveRefinementXML(abqXML.AbqXML):
    "This class specializes the abqXML class for Curve refinement settings export"

    ################################################################################

    def __init__(self):
        self.m_settingsModule = settingsModule
        abqXML.AbqXML.__init__(self)
        self.m_str = ["mdb.models[].parts[].geometryRefinement"]
        self.m_objLoadFuncList = [xmlUtils.readSetValuesObjects] + self.m_objLoadFuncList
        self.m_overwrite = True
        self.m_readSetValuesObjects = {'Part':['geometryRefinement']}

    ################################################################################
    
    def saveInfo(self):
        "This function saves the curve refinement settings of various parts into xmldoc"
        if "models" in mdb.__members__:
            if "parts" in mdb.models.values()[0].__members__:   # This check will fail if used in Abaqus/Viewer
                return self.parseAndAttachMultiple()
        raise AssertionError, "Cannot save the required information as the plug-in cannot navigate to mdb.models[modelName].parts[partName]. This is usually observed when the information is exported in Abaqus/Viewer instead of Abaqus/CAE."
        return None

    ################################################################################

    def loadInfo(self, saveEle):
        "This function loads the curve refinement settings from xmldoc"

        count = 0
        results = self.getMatchingKeys(self.m_str[0])
        for result in results:
            if result[0][0] in mdb.models.keys():
                if result[0][1] in mdb.models[result[0][0]].parts.keys():
                    results2 = self.detachAndReturn(result[1], [mdb.models[result[0][0]].parts[result[0][1]]])
                    count += self.numResults(results2)
        return count

################################################################################
